using System;
using System.Web;
using System.Web.UI.WebControls;

public partial class MasterPage : System.Web.UI.MasterPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            LoadTreeView();
        }
    }

    private void LoadTreeView()
    {
        for (int i = 0; i < 5; i++)
        {
            TreeNode treeNode = new TreeNode();
            treeNode.Text = "Node " + i.ToString();
            treeNode.Value = string.Empty;

            TreeNode subNode;

            subNode = new TreeNode();
            subNode.Text = "Page 1";
            subNode.Value = "Default.aspx";
            treeNode.ChildNodes.Add(subNode);

            subNode = new TreeNode();
            subNode.Text = "Page 2";
            subNode.Value = "Default2.aspx";
            treeNode.ChildNodes.Add(subNode);

            TreeViewMain.Nodes.Add(treeNode);
        }

        // set the default state of all nodes.
        TreeViewMain.CollapseAll();

        // get the saved state of all nodes.
        new TreeViewState().RestoreTreeView(TreeViewMain, this.GetType().ToString());
    }

    protected void TreeViewMain_SelectedNodeChanged(object sender, EventArgs e)
    {
        if (TreeViewMain.SelectedNode.Value != string.Empty)
        {
            Response.Redirect(TreeViewMain.SelectedNode.Value);
        }
    }

    protected void TreeViewMain_Unload(object sender, EventArgs e)
    {
        // save the state of all nodes.
        new TreeViewState().SaveTreeView(TreeViewMain, this.GetType().ToString());
    }
}